'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _immutable = require('immutable');

var _reduxImmutable = require('redux-immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MockStore = function (_Record) {
    _inherits(MockStore, _Record);

    function MockStore(reducer) {
        var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

        _classCallCheck(this, MockStore);

        (0, _invariant2.default)(typeof reducer === 'function', 'Reducer must be a function.');
        var finalPath = Array.isArray(path) ? path : [path];
        var finalReducer = finalPath.reduceRight(function (result, segment) {
            return (0, _reduxImmutable.combineReducers)(_defineProperty({}, segment, result));
        }, reducer);
        return _possibleConstructorReturn(this, (MockStore.__proto__ || Object.getPrototypeOf(MockStore)).call(this, {
            reducer: finalReducer,
            state: finalReducer(undefined, {})
        }));
    }

    _createClass(MockStore, [{
        key: 'apply',
        value: function apply() {
            for (var _len = arguments.length, actions = Array(_len), _key = 0; _key < _len; _key++) {
                actions[_key] = arguments[_key];
            }

            var newState = actions.reduce(this.reducer, this.state);
            return this.set('state', newState);
        }
    }, {
        key: 'select',
        value: function select(selector) {
            for (var _len2 = arguments.length, parameters = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                parameters[_key2 - 1] = arguments[_key2];
            }

            return selector.apply(undefined, [this.state].concat(parameters));
        }
    }]);

    return MockStore;
}((0, _immutable.Record)({ state: null, reducer: null }));

exports.default = MockStore;