"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var skipDependentTests = exports.skipDependentTests = function skipDependentTests(test) {
    var siblings = test.parent.tests;
    var index = siblings.indexOf(test);
    siblings.slice(index + 1).forEach(function (dependant) {
        dependant.pending = true; // eslint-disable-line no-param-reassign
    });
};

var executeCommandWithDependentTests = exports.executeCommandWithDependentTests = function executeCommandWithDependentTests(test, command) {
    try {
        command();
    } catch (error) {
        skipDependentTests(test);
        throw error;
    }
};