'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _mochaHelpers = require('./mochaHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var createAction = function createAction(args) {
    return args[0].apply(null, args.slice(1));
};

exports.default = function (actions) {
    return function when() {
        (0, _invariant2.default)(this.store, 'Given must be specified for when');

        try {
            var _store;

            var multiple = Array.isArray(actions[0]);
            var actualActions = multiple ? actions.map(createAction) : [createAction(actions)];
            this.store = (_store = this.store).apply.apply(_store, _toConsumableArray(actualActions));
        } catch (error) {
            (0, _mochaHelpers.skipDependentTests)(this.test);
            throw error;
        }
    };
};